Index: TXM/trunk/org.txm.treesearch.core/src/org/txm/treesearch/function/TreeSearch.java
===================================================================
--- TXM/trunk/org.txm.treesearch.core/src/org/txm/treesearch/function/TreeSearch.java	(revision 3547)
+++ TXM/trunk/org.txm.treesearch.core/src/org/txm/treesearch/function/TreeSearch.java	(revision 3548)
@@ -37,6 +37,9 @@
 	@Parameter(key = TreeSearchPreferences.NTFEATURE)
 	protected String NT;
 	
+	@Parameter(key = TreeSearchPreferences.VISUALISATION)
+	protected String pVisualisation;
+	
 
 	public TreeSearch(CQPCorpus corpus) {
 		
@@ -155,5 +158,11 @@
 	public abstract Selection getSelection();
 
 	public abstract File createTemporaryFile(File resultDir);
+
+	public abstract String[] getAvailableVisualisations();
+
+	public String getVisualisation() {
+		return pVisualisation;
+	}
 	
 }
Index: TXM/trunk/org.txm.treesearch.core/src/org/txm/treesearch/preferences/TreeSearchPreferences.java
===================================================================
--- TXM/trunk/org.txm.treesearch.core/src/org/txm/treesearch/preferences/TreeSearchPreferences.java	(revision 3547)
+++ TXM/trunk/org.txm.treesearch.core/src/org/txm/treesearch/preferences/TreeSearchPreferences.java	(revision 3548)
@@ -19,6 +19,8 @@
 	public static final String TFEATURE = "t";
 	
 	public static final String NTFEATURE = "nt";
+
+	public static final String VISUALISATION = "visualisation";
 	
 	/**
 	 * Gets the instance.
@@ -40,5 +42,6 @@
 		preferences.put(DEFAULT_VISUALISATION, "TIGER");
 		preferences.put(TFEATURE, "word");
 		preferences.put(NTFEATURE, "cat");
+		preferences.put(VISUALISATION, "");
 	}
 }
Index: TXM/trunk/org.txm.rcp/plugin.xml
===================================================================
--- TXM/trunk/org.txm.rcp/plugin.xml	(revision 3547)
+++ TXM/trunk/org.txm.rcp/plugin.xml	(revision 3548)
@@ -1584,10 +1584,6 @@
                </visibleWhen>
             </command>
          </toolbar>
-         <separator
-               name="org.txm.rcp.toolbar.separator1"
-               visible="false">
-         </separator>
          <toolbar
                id="org.txm.rcp.toolbarcorpus">
             <separator
Index: TXM/trunk/org.txm.tigersearch.rcp/src/org/txm/function/tigersearch/TIGERSearch.java
===================================================================
--- TXM/trunk/org.txm.tigersearch.rcp/src/org/txm/function/tigersearch/TIGERSearch.java	(revision 3547)
+++ TXM/trunk/org.txm.tigersearch.rcp/src/org/txm/function/tigersearch/TIGERSearch.java	(revision 3548)
@@ -346,4 +346,11 @@
 			return null;
 		} //$NON-NLS-1$ //$NON-NLS-2$ull;
 	}
+
+	@Override
+	public String[] getAvailableVisualisations() {
+		
+		// TODO Auto-generated method stub
+		return null;
+	}
 }
Index: TXM/trunk/org.txm.conllu.rcp/src/org/txm/conllu/rcp/preferences/UDTreePreferencePage.java
===================================================================
--- TXM/trunk/org.txm.conllu.rcp/src/org/txm/conllu/rcp/preferences/UDTreePreferencePage.java	(revision 3547)
+++ TXM/trunk/org.txm.conllu.rcp/src/org/txm/conllu/rcp/preferences/UDTreePreferencePage.java	(revision 3548)
@@ -22,7 +22,7 @@
 		
 		String[][] values = {{"DepTreeViz", UDTreePreferences.DEPTREEVIZ}, {"Brat", UDTreePreferences.BRAT}};
 		
-		this.addField(new ComboFieldEditor(UDTreePreferences.ENGINE, "Engine", values, this.getFieldEditorParent()));
+		this.addField(new ComboFieldEditor(UDTreePreferences.VISUALISATION, "Visualisation", values, this.getFieldEditorParent()));
 		
 		this.addField(new BooleanFieldEditor(UDTreePreferences.PRINTCONLLUSENTENCES, "Print CoNLL-U sentence when browsing the matches", this.getFieldEditorParent()));
 	}
Index: TXM/trunk/org.txm.connlu.core/groovy/org/txm/scripts/importer/conllu/CoNLLUImporter.groovy
===================================================================
--- TXM/trunk/org.txm.connlu.core/groovy/org/txm/scripts/importer/conllu/CoNLLUImporter.groovy	(revision 3547)
+++ TXM/trunk/org.txm.connlu.core/groovy/org/txm/scripts/importer/conllu/CoNLLUImporter.groovy	(revision 3548)
@@ -13,6 +13,7 @@
 import javax.xml.stream.*
 import org.txm.utils.AsciiUtils
 import org.txm.utils.ConsoleProgressBar
+import org.txm.utils.FileUtils
 import org.txm.conllu.core.preferences.UDPreferences
 /**
  * Only build the Metadatas object since all XML-TXM files already exists.
@@ -136,7 +137,7 @@
 			
 			def content = []; // list of sentence
 			
-			String text_id = master.getName();
+			String text_id = FileUtils.stripExtension(master);
 			String sent_id = "";
 			String par_id = "1";
 			def comments = []; // /text/par/sent
Index: TXM/trunk/org.txm.connlu.core/src/org/txm/conllu/core/preferences/UDTreePreferences.java
===================================================================
--- TXM/trunk/org.txm.connlu.core/src/org/txm/conllu/core/preferences/UDTreePreferences.java	(revision 3547)
+++ TXM/trunk/org.txm.connlu.core/src/org/txm/conllu/core/preferences/UDTreePreferences.java	(revision 3548)
@@ -13,8 +13,8 @@
  */
 public class UDTreePreferences extends TreeSearchPreferences {
 	
-	public static final String DEPTREEVIZ = "deptreeviz";
-	public static final String BRAT = "brat";
+	public static final String DEPTREEVIZ = "DepTreeViz";
+	public static final String BRAT = "Brat";
 	
 	public static final String ENGINE = "visu_engine";
 	public static final String PRINTCONLLUSENTENCES = "print_ud_seentence";
@@ -37,7 +37,7 @@
 		super.initializeDefaultPreferences();
 		
 		Preferences preferences = this.getDefaultPreferencesNode();
-		preferences.put(ENGINE, DEPTREEVIZ);
+		preferences.put(VISUALISATION, DEPTREEVIZ);
 		preferences.putBoolean(PRINTCONLLUSENTENCES, false);
 		preferences.put(TFEATURE, "");
 		preferences.put(NTFEATURE, "feats");
Index: TXM/trunk/org.txm.connlu.core/src/org/txm/conllu/core/function/UDSearch.java
===================================================================
--- TXM/trunk/org.txm.connlu.core/src/org/txm/conllu/core/function/UDSearch.java	(revision 3547)
+++ TXM/trunk/org.txm.connlu.core/src/org/txm/conllu/core/function/UDSearch.java	(revision 3548)
@@ -69,7 +69,7 @@
 		try {
 			//File file = File.createTempFile("txm", ".svg", new File(Toolbox.getTxmHomePath(), "results"));
 			
-			String engine = UDTreePreferences.getInstance().getString(UDTreePreferences.ENGINE);
+			//String engine = UDTreePreferences.getInstance().getString(UDTreePreferences.ENGINE);
 			
 			Match match = this.matches.getMatches().get(sent);
 			org.txm.objects.Match sentence = null;
@@ -122,7 +122,7 @@
 				}
 			}
 			
-			if (UDTreePreferences.BRAT.equals(engine)) {
+			if (UDTreePreferences.BRAT.equals(pVisualisation)) {
 				return BratPrintTree.print(svgFile, conll, Tvalues, NTvalues) != null;
 			} else { // if (engine == null || UDTreePreferences.DEPTREEVIZ.equals(engine)) {
 				return UDPrintTree.print(svgFile, conll, Tvalues, NTvalues) != null;
@@ -381,4 +381,10 @@
 			return null;
 		} //$NON-NLS-1$ //$NON-NLS-2$ull;
 	}
+
+	@Override
+	public String[] getAvailableVisualisations() {
+		
+		return new String[] {UDTreePreferences.DEPTREEVIZ, UDTreePreferences.BRAT};
+	}
 }
Index: TXM/trunk/org.txm.concordance.rcp/src/org/txm/concordance/rcp/editors/ConcordanceEditor.java
===================================================================
--- TXM/trunk/org.txm.concordance.rcp/src/org/txm/concordance/rcp/editors/ConcordanceEditor.java	(revision 3547)
+++ TXM/trunk/org.txm.concordance.rcp/src/org/txm/concordance/rcp/editors/ConcordanceEditor.java	(revision 3548)
@@ -381,10 +381,15 @@
 			
 			@Override
 			public String getColumnText(Object element, int columnIndex) {
+				
 				if (!(element instanceof Line)) return EMPTY;
 				
 				Line line = (Line) element;
-				return line.getViewRef().format();
+//				if (columnIndex == 0) {
+//					return Integer.toString(line.getKeywordPosition());
+//				} else {
+					return line.getViewRef().format();
+//				}
 			}
 		});
 		viewerLeft.setContentProvider(new ConcordancesProvider());
@@ -394,6 +399,11 @@
 		// firstColumn = new TableColumn(viewer2.getTable(), SWT.LEFT);
 		// firstColumn.setWidth(10);
 		
+//		TableColumn nColumn = new TableColumn(viewerLeft.getTable(), SWT.LEFT | SWT.H_SCROLL);
+//		nColumn.setText("N");
+//		nColumn.setToolTipText("N");
+//		nColumn.setWidth(30);
+		
 		referenceColumn = new TableColumn(viewerLeft.getTable(), SWT.LEFT | SWT.H_SCROLL);
 		refreshReferenceColumnTitle();
 		referenceColumn.setToolTipText(ConcordanceUIMessages.reference);
Index: TXM/trunk/org.txm.treesearch.rcp/src/org/txm/treesearch/editor/TreeSearchEditor.java
===================================================================
--- TXM/trunk/org.txm.treesearch.rcp/src/org/txm/treesearch/editor/TreeSearchEditor.java	(revision 3547)
+++ TXM/trunk/org.txm.treesearch.rcp/src/org/txm/treesearch/editor/TreeSearchEditor.java	(revision 3548)
@@ -87,10 +87,15 @@
 	
 	private Label representationLabel;
 	
+	@Parameter(key = TreeSearchPreferences.VISUALISATION)
+	private Combo visuCombo;
+	
+	private Label visuLabel;
+	
 	@Override
 	public void _createPartControl() {
 		
-		getMainParametersComposite().getLayout().numColumns = 3;
+		getMainParametersComposite().getLayout().numColumns = 5;
 		getMainParametersComposite().getLayout().makeColumnsEqualWidth = false;
 		
 		SelectionListener selChangedListener = new SelectionListener() {
@@ -147,6 +152,24 @@
 		representationCombo.setLayoutData(gdataR);
 		representationCombo.addSelectionListener(selChangedListener);
 		
+		// System.out.println(parent.getLayout());
+		Composite queryPanel = this.getExtendedParametersGroup();
+		
+		// fill query Area
+		GridLayout qlayout = new GridLayout(1, false);
+		qlayout.horizontalSpacing = 0;
+		// qlayout.verticalSpacing = 0;
+		queryPanel.setLayout(qlayout);
+		
+		visuLabel = new Label(getMainParametersComposite(), SWT.NONE);
+		visuLabel.setToolTipText("Visualisation mode");
+		visuLabel.setText("Visualisation");
+		
+		visuCombo = new Combo(getMainParametersComposite(), SWT.READ_ONLY);
+		GridData gdataV = new GridData(SWT.FILL, SWT.CENTER, false, false);
+		visuCombo.setLayoutData(gdataV);
+		visuCombo.addSelectionListener(selChangedListener);
+		
 		Button editionButton = new Button(getMainParametersComposite(), SWT.PUSH);
 		editionButton.setImage(IImageKeys.getImage(IImageKeys.EDITION));
 		editionButton.addSelectionListener(new SelectionListener() {
@@ -174,16 +197,6 @@
 			public void widgetDefaultSelected(SelectionEvent e) {}
 		});
 		
-		// System.out.println(parent.getLayout());
-		Composite queryPanel = this.getExtendedParametersGroup();
-		
-		// fill query Area
-		GridLayout qlayout = new GridLayout(1, false);
-		qlayout.horizontalSpacing = 0;
-		// qlayout.verticalSpacing = 0;
-		queryPanel.setLayout(qlayout);
-		
-		
 		// first line
 		GLComposite line1 = new GLComposite(queryPanel, SWT.NONE, "line1");
 		line1.getLayout().numColumns = 13;
@@ -314,8 +327,30 @@
 		if (ntFeatures.length > 0) {
 			NTCombo.setItems(ntFeatures);
 			NTCombo.setText(ts.getNT());
+			NTCombo.setEnabled(true);
 		}
+		else {
+			NTCombo.removeAll();
+			NTCombo.setText("");
+			NTCombo.setEnabled(false);
+		}
 		
+		String[] visuFeatures = ts.getAvailableVisualisations();
+		if (visuFeatures != null && visuFeatures.length > 0) {
+			visuCombo.setItems(visuFeatures);
+			visuCombo.setText(ts.getVisualisation());
+			visuCombo.setEnabled(true);
+			visuCombo.setVisible(true);
+			visuLabel.setVisible(true);
+		}
+		else {
+			visuCombo.removeAll();
+			visuCombo.setText("");
+			visuCombo.setEnabled(false);
+			visuCombo.setVisible(false);
+			visuLabel.setVisible(false);
+		}
+		
 		if (representationCombo.getItemCount() == 0) {
 			HashMap<String, TreeSearchSelector> selectors = ComputeTreeSearch.getSelectorsForCorpus(corpus);
 			Log.fine(Messages.bind(Messages.SyntaxRepresentationP0, selectors));
@@ -375,6 +410,8 @@
 		// System.out.println("Corpus '" + id + "' is not ready.");
 		// return;
 		// }
+		
+		getMainParametersComposite().getParent().layout();
 	}
 	
 	/**
Index: TXM/trunk/org.txm.treesearch.rcp/plugin.xml
===================================================================
--- TXM/trunk/org.txm.treesearch.rcp/plugin.xml	(revision 3547)
+++ TXM/trunk/org.txm.treesearch.rcp/plugin.xml	(revision 3548)
@@ -59,11 +59,10 @@
          point="org.eclipse.ui.menus">
          <menuContribution
             allPopups="false"
-            locationURI="popup:org.txm.rcp.views.corpora.CorporaView?after=org.txm.rcp.corporaview.annotation">
+            locationURI="popup:org.txm.rcp.views.corpora.CorporaView?before=org.txm.rcp.corporaview.corpus.manage">
          <command
                commandId="org.txm.treesearch.command.ComputeTreeSearch"
                icon="icons/functions/Tree.png"
-               label="%command.label"
                style="push">
             <visibleWhen
                   checkEnabled="true">
@@ -79,11 +78,10 @@
       </menuContribution>
       <menuContribution
             allPopups="false"
-            locationURI="toolbar:org.txm.rcp.toolbartools">
+            locationURI="toolbar:org.txm.rcp.toolbarcorpus?after=org.txm.rcp.toolbarcorpus.read">
          <command
                commandId="org.txm.treesearch.command.ComputeTreeSearch"
                icon="icons/functions/Tree.png"
-               label="%command.label"
                style="push">
             <visibleWhen
                   checkEnabled="false">
@@ -97,6 +95,25 @@
             </visibleWhen>
          </command>
       </menuContribution>
+      <menuContribution
+            allPopups="false"
+            locationURI="menu:menu.corpus?before=menu.corpus.build">
+         <command
+               commandId="org.txm.treesearch.command.ComputeTreeSearch"
+               icon="icons/functions/Tree.png"
+               style="push">
+            <visibleWhen
+                  checkEnabled="false">
+               <or>
+                  <test
+                        forcePluginActivation="true"
+                        property="org.txm.rcp.testers.TreeSearchReady"
+                        value="TreeSearchReady">
+                  </test>
+               </or>
+            </visibleWhen>
+         </command>
+      </menuContribution>
       
    </extension>
    <extension
